/* IRCfs - IRC FileServ for *nix.
 * Copyright (C) 2002  Nick 'Zaf' Clifford <zaf@nrc.co.nz>
 * For licensing details, refer to the LICENSE file in the source 
 * code directory.
 */
#ifndef __include_runtime_h__
#define __include_runtime_h__

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef ENABLE_DEBUG
#define ENABLE_STATS
#endif

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <errno.h>
#if STDC_HEADERS
# include <string.h>
#else
# if !HAVE_STRCHR
#  define strchr index
#  define strrchr rindex
# endif
char *strchr (), *strrchr ();
# if !HAVE_MEMCPY
#  define memcpy(d, s, n) bcopy ((s), (d), (n))
#  define memmove(d, s, n) bcopy ((s), (d), (n))
# endif
#endif



#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

#include "pool.h"
#include "debug.h"
#include "misc.h"
#include "obj.h"

#define ASSERT	assert

#define XMALLOC(p,s)	((s *) palloc(p,sizeof(s)))
#define XMALLOCN(p,s,n)	((s **) palloc(p,sizeof(s) * n))
#define XSTRDUP(p,s)	(pstrdup(p,s))
#define XFREE(x)	;

#endif
